import threading
import time
from lib.controller import *
from lib.display import *

started = None
delay_sec = None
text = None
active = None


def thread_display():
    global started, delay_sec, text, active
    display.set_attr("txt_button_start.enabled", str(True).lower())
    display.set_attr("txt_slider_delay.enabled", str(True).lower())
    while True:
        display.set_attr("txt_label_text.text", str(text))
        display.set_attr("txt_status_indicator_green.active", str(active).lower())
        display.set_attr("txt_status_indicator_red.active", str(not active).lower())
        time.sleep(0.2)


def on_txt_button_start_clicked(event):
    global started, delay_sec, text, active
    started = True
    print('START pressed')


def on_txt_slider_delay_moved(event):
    global started, delay_sec, text, active
    delay_sec = int(event['value'])
    print('delay time changed')


display.button_clicked("txt_button_start", on_txt_button_start_clicked)
display.slider_moved("txt_slider_delay", on_txt_slider_delay_moved)


print('init variables...')
started = False
delay_sec = 1
text = 'Initialization'
print('start display thread...')
threading.Thread(target=thread_display, daemon=True).start()
print('start main loop')
while True:
    text = 'Ready'
    print('wait until [START] is pressed...')
    while True:
        if started:
            break
        time.sleep(0.010)
    text = 'RUN'
    print('RUN')
    while started:
        active = True
        time.sleep(delay_sec)
        active = False
        time.sleep(delay_sec)


